from bzv.infra import Infra
from bzv.customerConfig import CustomerConfig

from bzv.inbox import Inbox
from bzv.server import main
from merescocore.components import readConfig
from merescocore.components.http import ObservableHttpServer
from merescocore.framework import be
from sys import stdout
from weightless import Reactor
import sys
from sys import argv

import  os
import string


args = argv[1:]
if len(args) == 1:
	configFile = args[0]
	config = readConfig(configFile)

baseURL = config['baseURL']
portNumber = int(config['portNumber'])
sruUpdatePortNumber = int(config['sruUpdatePortNumber'])
databasePath = config['databasePath']
if portNumber < 1024 and not isRootUser():
	print 'Need root privileges.'
	exit(123)

websiteConfigfile = config['websiteConfig']
serverConfigfile  = config['serverConfig']
loggingConfigfile = config['loggingConfig']

infra = Infra('Starting MerescoServer',loggingConfigfile=loggingConfigfile)

websiteConfig = CustomerConfig(websiteConfigfile,infra)
serverConfig  = CustomerConfig(serverConfigfile,infra)
configs = {'website': websiteConfig, 'server': serverConfig}

print 'Firing up Tilburg Beter Zoeken & Vinden Server.'
reactor = Reactor()
observableHttpServer = ObservableHttpServer(reactor, portNumber)
observableHttpServer.startServer()
if portNumber < 1024:
	runAs(config['username'], config['groupname'])

sruUpdateServer = ObservableHttpServer(reactor, sruUpdatePortNumber, prio=9)

inbox = Inbox(reactor=reactor, inboxDirectory=config['inboxDirectory'],
	      doneDirectory=config['doneDirectory'], infra=infra)

server = be(main(reactor, observableHttpServer, sruUpdateServer, inbox, baseURL, portNumber,\
			 databasePath, config, infra, configs))

server.once.observer_init()

inbox.processInboxDirectory()

print "Ready to rumble on", baseURL, "at ports", portNumber, sruUpdatePortNumber
print "   - database:", databasePath, "\n"
stdout.flush()
reactor.loop()
